import { FileHandle, open } from 'fs/promises'

async function findHungryElfs(file: FileHandle): Promise<number> {
  const topCalories = [0, 0, 0]
  let currentCalories = 0

  for await (const line of file.readLines()) {
    if (/^\s*$/.test(line)) {
      topCalories.push(currentCalories)
      topCalories.sort((a, b) => a - b).splice(0, 1)
      currentCalories = 0
    } else {
      currentCalories += parseInt(line)
    }
  }

  return topCalories.reduce((x, total) => x + total, 0)
}

async function run() {
  const input = process.argv.slice(2)[0]
  const fd = await open(input)
  const totalCalories = await findHungryElfs(fd)

  console.log(`solution: ${totalCalories}`)
}

run()
