import { FileHandle, open } from 'fs/promises'

function findMarker(line: string): number {
  const buffer: string[] = []
  const difference = 14
  let marker = 0

  for (let i = 0; i < line.length; i++) {
    const character = line[i]

    if (buffer.includes(character)) {
      buffer.splice(0, buffer.indexOf(character) + 1)
    }

    if (!buffer.includes(character)) {
      buffer.push(character)
      marker = i + 1
      if (buffer.length === difference) {
        break
      }
    }
  }

  if (process.env.DEBUG) {
    console.log(buffer)
  }

  return marker
}

async function solve(file: FileHandle): Promise<void> {
  for await (const line of file.readLines()) {
    const solution = findMarker(line)
    console.log(`solution: ${solution}`)
  }
}

async function run() {
  const input = process.argv.slice(2)[0]
  const fd = await open(input)
  await solve(fd)
}

run()
